//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "Unit2.h"
#include "Unit1.h"
#include "func.h"
#define MAX 2048
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm2 *Form2;
//---------------------------------------------------------------------------
__fastcall TForm2::TForm2(TComponent* Owner)
	: TForm(Owner)
{
	ComboBoxR->ItemIndex=0;
	ComboBoxC->ItemIndex=1;
}
//---------------------------------------------------------------------------
void __fastcall TForm2::ButtonMakeClick(TObject *Sender)
{

	EditMes->Text="";

	int qr=ComboBoxR->ItemIndex,
      	qc=ComboBoxC->ItemIndex,
        qq=ComboBoxQ->ItemIndex;


    if(qr*qc!=0){
    	EditMes->Text="Select T either in ROW or COLUMN, and another(P, rho)";
        return;
    }
	if(qr==qc){
       	EditMes->Text="Select T either in ROW or COLUMN";
       	return;
    }

	if(qq==-1){
       	EditMes->Text="Select the properties you want.";
       	return;
    }

	if(qq==qr-1||qq==qc-1){	//selected quantity is same as ROW or COLUMN
       	EditMes->Text="the selected quantities are same.";
       	return;
    }
    AnsiString rs,cs;


    rs=EditR->Text;
    cs=EditC->Text;

	double tpd[3][MAX],*pd;
    int rmax,cmax;
    bool mode3c;


    if(RadioGroupTableType->ItemIndex==0) mode3c=false;  //TYPE I
    else mode3c=true;   //TYPE II

    if(!mode3c){
	    pd=tpd[qr];
        if(rs=="") rmax=0;
    	else rmax=AnsiStrTokenToDouble(rs,pd);

		pd=tpd[qc];
        if(cs=="") cmax=0;
		else cmax=AnsiStrTokenToDouble(cs,pd);

        if(qq>=2&&qq<=5||qq==16){
                //Saturation Properties and Melting Pressure for T
            Form1->RadioGroupVar->ItemIndex=0;
            Form1->RadioGroupVar->OnClick(this);
            Form1->ButtonSetCp->OnClick(this);
            if(qr==0){
                cmax=1;
                qc=1;
                tpd[qc][0]=Form1->EditP->Text.ToDouble();
            }
            if(qc==0){
                rmax=1;
                qr=1;
                tpd[qr][0]=Form1->EditP->Text.ToDouble();
            }
        }

    }else{

        FILE *fo;
        fo=fopen(Editopen->Text.c_str(),"rt");

        char s[MAX];
        int ii=0,sl=Editskipline->Text.ToInt();

        for(int jj=0;jj<sl;jj++) fgets(s,MAX,fo);

        while(fgets(s,MAX,fo)!=NULL){
        	AnsiString asz=AnsiString(s);
            int it=asz.Pos("\t");

            if(it<=1) continue;
            tpd[qr][ii]=(asz.SubString(1,it-1)).ToDouble();
            asz.Delete(1,it);

            it=asz.Pos("\t");
            if(it<=1) it=asz.Pos("\n");
            if(it<=1) it=asz.Length()+1;
            tpd[qc][ii]=(asz.SubString(1,it-1)).ToDouble();
        	ii++;
        }
        rmax=ii;
        cmax=ii;
        fclose(fo);
    }

	if(rmax*cmax==0){
       	EditMes->Text="The number of values in either ROW or COLUMN is 0 or missed.";
       	return;
    }

	if(SaveDialog1->Execute()){

        Form1->RadioGroupVar->ItemIndex=qr+qc-1;
                                    //either is temperature (index=0)
		Form1->EditMes->Text="";
        TEdit *pEdit[]={
            Form1->EditT,
        	Form1->EditP,
        	Form1->EditRho,
        	Form1->EditmeltP,
        	Form1->EditsatuP,
        	Form1->EditsatuRhov,
        	Form1->EditsatuRhol,
        	Form1->EditU,
			Form1->EditH,
        	Form1->EditF,
        	Form1->EditG,
        	Form1->EditCv,
        	Form1->EditCp,
        	Form1->EditZ,
        	Form1->EditFP,
        	Form1->EditW,
        	Form1->EditJT,
        	Form1->EditC2,
        	Form1->Editalpha,
        	Form1->Editkappa,
        	Form1->EditVisc,
			Form1->EditTherc,
			Form1->EditDth,
        	Form1->EditEps,
        	Form1->EditKw,
        	Form1->Editn
        };



        FILE *outx;

        outx=fopen(SaveDialog1->FileName.c_str(),"wt");

        AnsiString qas[]={"T","P","rho"},
        qunit[]={
            Form1->asT[Form1->unitT],
            Form1->asP[Form1->unitP],
            Form1->asRho[Form1->unitRho],
        	Form1->LabelmeltP->Caption,
        	Form1->LabelsatuP->Caption,
        	Form1->LabelsatuRhov->Caption,
        	Form1->LabelsatuRhol->Caption,
        	Form1->LabelU->Caption,
			Form1->LabelH->Caption,
        	Form1->LabelF->Caption,
        	Form1->LabelG->Caption,
        	Form1->LabelCv->Caption,
        	Form1->LabelCp->Caption,
        	"", // Z
        	"", // F/P
        	Form1->LabelW->Caption,
        	Form1->LabelJT->Caption,
        	Form1->LabelC2->Caption,
        	Form1->Labelalpha->Caption,
        	Form1->Labelkappa->Caption,
        	Form1->LabelVisc->Caption,
			Form1->LabelTherc->Caption,
			Form1->LabelDth->Caption,
        	"", // eps
        	"", //Kw
        	Form1->Labeln1->Caption + " " +
                Form1->Editnlambda->Text + " " +
                Form1->Labeln2->Caption //n at L nm.
        };

        if(!Form1->Rho_on)qunit[2]=Form1->asV[Form1->unitRho];

        fprintf(outx,(ComboBoxQ->Items->Strings[qq]+" ("+qunit[qq+1]+") of "
            +Form1->RadioGroupMatter->Items->Strings[Form1->RadioGroupMatter->ItemIndex]
            +"\n").c_str());
                                            //qq+1 means exception of EditT

        if(!mode3c){

        	fprintf(outx,
        		(qas[qr]+" ("+qunit[qr]+") / "
				+qas[qc]+" ("+qunit[qc]+")").c_str());
	        for(int cx=0;cx<cmax;cx++) fprintf(outx,("\t"+AnsiString(tpd[qc][cx])).c_str());

	        if(CheckProcess->Checked){
	        	for(int rx=0;rx<rmax;rx++){
	        		pEdit[qr]->Text=ASDigit(tpd[qr][rx]);
		    	    fprintf(outx,("\n"+AnsiString(tpd[qr][rx])).c_str());
	        		for(int cx=0;cx<cmax;cx++){
	        			pEdit[qc]->Text=ASDigit(tpd[qc][cx]);
						Form1->ButtonCalc->OnClick(this);
						Application->ProcessMessages();
                						//this is needed to be output correctly
	        		    fprintf(outx,("\t"+pEdit[qq+1]->Text).c_str());
                							//qq+1 means exception of EditT.
	        		}
	        	}
	        }else{
	        	for(int rx=0;rx<rmax;rx++){
	        		pEdit[qr]->Text=ASDigit(tpd[qr][rx]);
		    	    fprintf(outx,("\n"+AnsiString(tpd[qr][rx])).c_str());
	        		for(int cx=0;cx<cmax;cx++){
	        			pEdit[qc]->Text=ASDigit(tpd[qc][cx]);
						Form1->ButtonCalc->OnClick(this);
						Update();
                						//this is needed to be output correctly
	        		    fprintf(outx,("\t"+pEdit[qq+1]->Text).c_str());
                							//qq+1 means exception of EditT.
	        		}
	        	}
	        }

		}else{

        	fprintf(outx,
        		(qas[qr]+" ("+qunit[qr]+")\t"
				+qas[qc]+" ("+qunit[qc]+")\t"
                +ComboBoxQ->Items->Strings[qq]+" ("+qunit[qq+1]+")").c_str());
                                           //qq+1 means exception of EditT.
	        if(CheckProcess->Checked){
	        	for(int rx=0;rx<rmax;rx++){
	        		pEdit[qr]->Text=ASDigit(tpd[qr][rx]);
        			pEdit[qc]->Text=ASDigit(tpd[qc][rx]);
					Form1->ButtonCalc->OnClick(this);
					Application->ProcessMessages();
                						//this is needed to be output correctly

		    	    fprintf(outx,("\n"+AnsiString(tpd[qr][rx])
                    				+"\t"+ AnsiString(tpd[qc][rx])
                                    +"\t"+ pEdit[qq+1]->Text).c_str());
                							//qq+1 means exception of EditT.
	        	}
	        }else{
	        	for(int rx=0;rx<rmax;rx++){
	        		pEdit[qr]->Text=ASDigit(tpd[qr][rx]);
        			pEdit[qc]->Text=ASDigit(tpd[qc][rx]);
					Form1->ButtonCalc->OnClick(this);
					Update();		//this is needed to be output correctly

		    	    fprintf(outx,("\n"+AnsiString(tpd[qr][rx])
                    				+"\t"+ AnsiString(tpd[qc][rx])
                                    +"\t"+ pEdit[qq+1]->Text).c_str());
                							//qq+1 means exception of EditT.
	        	}
	        }

		}



        fclose(outx);
        EditMes->Text="The table has been made successfully.";
    }
}
//---------------------------------------------------------------------------
int __fastcall TForm2::AnsiStrTokenToDouble(AnsiString xas,double* xd)
{
	AnsiString zas=xas;
    int ix=0;
    while(zas.Pos(",")!=0&&ix<MAX){
    	int pr=zas.Pos(",");
		if(pr>=2){
        	*(xd+ix)=atof((zas.SubString(1,pr-1)).c_str());
        	ix++;
		}
        zas.Delete(1,pr);
    }
    *(xd+ix)=atof(zas.c_str());
	return ix+1;
}
//---------------------------------------------------------------------------
void __fastcall TForm2::ButtonRsClick(TObject *Sender)
{
    double xr[3];
	if(AnsiStrTokenToDouble(EditRs->Text,xr)!=3){
    	EditR->Text="The series format should be \"x,y,z\".";
        return;
    };
    if(xr[2]<1){
    	EditR->Text="z should be integar more than 0.";
        return;
    }
    AnsiString as=AnsiString(xr[0]);
    for(int xx=1;xx<xr[2];xx++) as+=","+AnsiString(xr[0]+xx*xr[1]);
	EditR->Text=as;
}
//---------------------------------------------------------------------------
void __fastcall TForm2::ButtonCsClick(TObject *Sender)
{
    double xc[3];
	if(AnsiStrTokenToDouble(EditCs->Text,xc)!=3){
    	EditC->Text="The series format should be \"x,y,z\".";
        return;
    };
    if(xc[2]<1){
    	EditC->Text="z should be integar more than 0.";
        return;
    }
    AnsiString as=AnsiString(xc[0]);
    for(int xx=1;xx<xc[2];xx++) as+=","+AnsiString(xc[0]+xx*xc[1]);
	EditC->Text=as;
}
//---------------------------------------------------------------------------
void __fastcall TForm2::FormShow(TObject *Sender)
{
	Form2->Left=Screen->Width/2-Form2->Width/2;
	Form2->Top=Screen->Height/2-Form2->Height/2;
}
//---------------------------------------------------------------------------
void __fastcall TForm2::ButtonRefClick(TObject *Sender)
{
	if(OpenDialog1->Execute()) Editopen->Text = OpenDialog1->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TForm2::RadioGroupTableTypeClick(TObject *Sender)
{
    bool b;
    if(RadioGroupTableType->ItemIndex==0){
        LabelR->Caption="ROW";
        LabelC->Caption="COLUMN";
        b=true;
    }
    if(RadioGroupTableType->ItemIndex==1){
        LabelR->Caption="1st COLUMN";
        LabelC->Caption="2nd COLUMN";
        b=false;
    }

    LabelRs->Enabled=b;
    ButtonRs->Enabled=b;
    LabelCs->Enabled=b;
    ButtonCs->Enabled=b;
    EditSW(EditR,b);
    EditSW(EditRs,b);
    EditSW(EditC,b);
    EditSW(EditCs,b);
    EditSW(Editopen,!b);
    EditSW(Editskipline,!b);
    Labelopen->Enabled=!b;
    Labelskipline->Enabled=!b;
    ButtonRef->Enabled=!b;
}
//---------------------------------------------------------------------------
void __fastcall TForm2::EditSW(TEdit *Ed,bool on_off)
{
    if(on_off){
        Ed->Enabled=true;
        Ed->Color=clWindow;
    }else{
        Ed->Enabled=false;
        Ed->Color=clBtnFace;
    }
}
//---------------------------------------------------------------------------

